// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/telemetry_default
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/members -i Members -t ../../../assets/templates/middleware/telemetry_default -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	pkgId "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/members"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements members.Members interface instrumented with opentracing spans
type telemetryMiddleware struct {
	members.Members
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base members.Members, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Members:        base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Get implements members.Members
func (_d telemetryMiddleware) Get(ctx context.Context, orgId string, userId string) (role members.Role, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.Get")
	defer _span.End()

	role, err = _d.Members.Get(ctx, orgId, userId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"orgId":  orgId,
			"userId": userId}, map[string]interface{}{
			"role": role,
			"err":  err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return role, err
}

// ListMembers implements members.Members
func (_d telemetryMiddleware) ListMembers(ctx context.Context, orgId string) (members []*members.Member, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "ListMembers"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.ListMembers")
	defer _span.End()

	members, err = _d.Members.ListMembers(ctx, orgId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"orgId": orgId}, map[string]interface{}{
			"members": members,
			"err":     err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return members, err
}

// ListOrganizations implements members.Members
func (_d telemetryMiddleware) ListOrganizations(ctx context.Context, userId string) (organizations []*members.Member, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "ListOrganizations"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.ListOrganizations")
	defer _span.End()

	organizations, err = _d.Members.ListOrganizations(ctx, userId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"userId": userId}, map[string]interface{}{
			"organizations": organizations,
			"err":           err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return organizations, err
}

// Remove implements members.Members
func (_d telemetryMiddleware) Remove(ctx context.Context, orgId string, userId string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "Remove"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.Remove")
	defer _span.End()

	err = _d.Members.Remove(ctx, orgId, userId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"orgId":  orgId,
			"userId": userId}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// RemoveAll implements members.Members
func (_d telemetryMiddleware) RemoveAll(ctx context.Context, orgId string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "RemoveAll"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.RemoveAll")
	defer _span.End()

	err = _d.Members.RemoveAll(ctx, orgId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":   ctx,
			"orgId": orgId}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Set implements members.Members
func (_d telemetryMiddleware) Set(ctx context.Context, orgId string, userId string, role members.Role) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Members"),
		attribute.String("method", "Set"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Members.Set")
	defer _span.End()

	err = _d.Members.Set(ctx, orgId, userId, role)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"orgId":  orgId,
			"userId": userId,
			"role":   role}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}
