// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/roles -i Roles -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/roles"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements roles.Roles that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   roles.Roles
}

// AccessLoggingMiddleware instruments an implementation of the roles.Roles with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next roles.Roles) roles.Roles {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, role *roles.Role) (created *roles.Role, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("role", role),
	)

	created, err = m.next.Create(ctx, role)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, spaceId string, id string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	err = m.next.Delete(ctx, spaceId, id)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, id string) (role *roles.Role, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("id", id),
	)

	role, err = m.next.Get(ctx, spaceId, id)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("role", role),
		zap.Error(err),
	)

	return role, err
}

func (m *accessLoggingMiddleware) List(ctx context.Context, spaceId string) (roles []*roles.Role, err error) {
	begin := time.Now()

	m.logger.Debug("List.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
	)

	roles, err = m.next.List(ctx, spaceId)

	m.logger.Debug("List.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("roles", roles),
		zap.Error(err),
	)

	return roles, err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, role *roles.Role) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("role", role),
	)

	err = m.next.Update(ctx, role)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
