package yaml

import (
	"io"

	"git.perx.ru/perxis/perxis-go/pkg/errors"
	"gopkg.in/yaml.v3"
)

// FileResolver подключает содержимое целевого файла в качестве значения поля.
func FileResolver(tp TagProcessor, node *yaml.Node) (*yaml.Node, error) {
	if node.Kind != yaml.ScalarNode {
		return nil, errors.New("!include on a non-scalar node")
	}

	file, err := tp.FS().Open(node.Value)
	if err != nil {
		return nil, err
	}
	defer func() { _ = file.Close() }()

	bytes, err := io.ReadAll(file)
	if err != nil {
		return nil, err
	}

	out := new(yaml.Node)
	out.SetString(string(bytes))

	return out, err
}
